## snek 1.9

=== Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT = .

include snek-install.defs

SNEK_OTHEROS_DIR=$(SNEK_HOSTS)/linux $(SNEK_HOSTS)/windows $(SNEK_HOSTS)/macosx $(SNEK_HOSTS)/zip

SUBDIRS = snekde doc examples

SNEKS = $(SNEK_PORTS)/posix/snek $(FIRMWARE)

all: $(SNEKS)
	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR)) || exit 1; done

$(SNEKS): FORCE
	+cd `dirname $@` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR)

FORCE:

check: all
	+cd test && make $@

black:
	+black --check --exclude 'fail-syntax-.*\.py|.*/hosts/.*.py' .

black-reformat:
	+black --exclude 'fail-syntax-.*\.py|.*/hosts/.*.py' .

install: all
	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@) || exit 1; done
	+for snek in $(SNEKS); do (cd `dirname $$snek` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@) || exit 1; done

upload: otheros
	+cd doc && make upload
	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make upload); done

install-otheros: otheros install
	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make install-otheros); done

otheros: all
	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make); done

snek-mu.py:
	find . -name '*.builtin' -print0 | xargs -0 python3 ./snek-builtin.py --mu -o $@

docker:
	docker build -t phsilva/snek .

clean:
	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@); done
	+for snek in $(SNEKS); do (cd `dirname $$snek` && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@); done

=== doc/Makefile ===
SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT=..

include $(SNEK_ROOT)/snek-install.defs

.SUFFIXES: .adoc .pdf .html

ADOC_FILES=snek.adoc

PDF_FILES=$(ADOC_FILES:.adoc=.pdf)
HTML_FILES=$(ADOC_FILES:.adoc=.html)
CSS_FILES=snek.css coderay-asciidoctor.css
IMAGE_FILES=../snek.svg

all: $(HTML_FILES) $(PDF_FILES) all-lessons

BOOK_FILES=snek-book.pdf snek-cover.pdf snek-book-book.pdf snek-cover-book.pdf

book: $(BOOK_FILES)

LETTER_ATTRIBUTES=--attribute='pdf-theme=snek' 
BOOK_ATTRIBUTES=--attribute='pdf-theme=snek-book' 
ATTRIBUTES=--attribute="revdate=$(SNEK_DATE)" --attribute="version=$(SNEK_VERSION)"

.adoc.html:
	asciidoctor -v -B$(SNEK_ROOT) $(ATTRIBUTES) -b html5 $*.adoc

.adoc.pdf:
	asciidoctor-pdf -B$(SNEK_ROOT) $(ATTRIBUTES) $(LETTER_ATTRIBUTES) $*.adoc

$(PDF_FILES): snek-theme.yml $(IMAGE_FILES)

DOCFILES=$(PDF_FILES) $(HTML_FILES) $(CSS_FILES) $(IMAGE_FILES)

install: $(DOCFILES) install-lessons
	install -d $(DESTDIR)$(DOCDIR)
	for i in $(DOCFILES); do install --mode=644 "$$i" $(DESTDIR)$(DOCDIR) || exit 1; done

snek-book.pdf: snek.adoc snek-book-theme.yml
	asciidoctor-pdf -o `pwd`/$@ -B$(SNEK_ROOT) $(ATTRIBUTES) $(BOOK_ATTRIBUTES) snek.adoc

snek-book-book.pdf: snek-book.pdf
	pdfbook2 -n --paper=letter snek-book.pdf

snek-cover.pdf: snek-cover.svg
	rsvg-convert -d 72 -p 72 -f pdf -o $@ $^

snek-cover-book.pdf: snek-cover.svg
	rsvg-convert -d 69.05 -p 69.94 -f pdf -o $@ $^

upload: $(DOCFILES) upload-lessons
	rsync -avz $(DOCFILES) fonts $(SNEKDOC)

coderay-asciidoctor.css: $(HTML_FILES)

clean:: clean-lessons
	rm -f $(PDF_FILES) $(HTML_FILES) $(BOOK_FILES) coderay-asciidoctor.css

all-lessons:
	+for i in lessons/lesson-*; do make -C $$i all; done

clean-lessons:
	+for i in lessons/lesson-*; do make -C $$i clean; done

upload-lessons:
	+for i in lessons/lesson-*; do make -C $$i upload; done

install-lessons:
	+for i in lessons/lesson-*; do make -C $$i DESTDIR=$(DESTDIR) DOCDIR=$(DOCDIR) install; done

=== hosts/windows/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT=../..

SNEK_LOCAL_SRC = \
	snek-windows.c \
	snek-math.c \
	snek-input.c

SNEK_LOCAL_INC = snek-windows.h
SNEK_LOCAL_BUILTINS = snek-windows.builtin $(SNEK_ROOT)/snek-math.builtin $(SNEK_ROOT)/snek-input.builtin

INF=altusmetrum.inf
WINDOWS_FILES=snek.exe snek.ico snekde.py $(PDF) $(SNEK_ROOT)/examples $(SNEK_ROOT)/COPYING $(FIRMWARE) $(USBFIRMWARE) $(INF)

include $(SNEK_ROOT)/snek-install.defs

WINDOWS_INSTALL=build/nsis/snek-windows-$(SNEK_VERSION_DASH).exe

CC=i686-w64-mingw32-gcc
MINGFLAGS=-Wall -Wextra -mconsole

OPT=-O0

CFLAGS=$(OPT) -g -I. $(SNEK_CFLAGS) $(MINGFLAGS)

LIBS=-lm

all: $(WINDOWS_INSTALL)

$(WINDOWS_INSTALL): $(WINDOWS_FILES) snek.cfg
	pynsist snek.cfg

snek.cfg: snek.cfg.in $(SNEK_ROOT)/snek-install.defs $(SNEK_ROOT)/snek.defs
	for i in $(FIRMWARE); do echo "	$$i"; done | sed '/@SNEK_FIRMWARE@/r /dev/stdin' snek.cfg.in | sed '/@SNEK_FIRMWARE/d' | $(SNEK_SED) > $@

snek.exe: $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $(SNEK_OBJ) $(LIBS)

vpath %.svg $(SNEK_ROOT)

snekde.py: $(SNEK_ROOT)/snekde/snekde.py
	cp $^ $@

.SUFFIXES: .svg .build .icns .ico .rc .o .exe

.svg.build:
	for i in $(RES); do rsvg-convert -w $$i -h $$i -o $*-$$i.png $^ || exit 1; done && touch $@

.build.ico:
	icotool -c -o $@ $(shell for i in $(RES); do echo $*-$$i.png; done)

.ico.rc:
	./make-rc "$*" $(VERSION) > $@

RES=16 24 32 48 64 72 96 128 180 256

install:
	echo install done

install-otheros: $(WINDOWS_INSTALL)
	cp $(WINDOWS_INSTALL) $(DESTDIR)$(PREFIX)

upload: $(WINDOWS_INSTALL)
	rsync -avz $(WINDOWS_INSTALL) $(SNEKDIST)

clean::
	rm -f snek.exe snek.ico snekde.py snek.cfg snek-*.png
	rm -rf build

=== ports/duemilanove-big/Makefile ===
#
# Copyright © 2020 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

vpath %.in ../duemilanove-big

BOARD?=duemilanove-big
CBOARD?=Duemilanove-big
UBOARD?=DUEMILANOVE-BIG
PORT?=/dev/ttyUSB0
INSTALLER?=0

ATMEGA_FLASH_SIZE=0x8000

SNEK_ATMEGA_SRC_EXTRA ?= \
	snek-input.c

SNEK_ATMEGA_BUILTINS_EXTRA ?= \
	snek-input.builtin

include ../duemilanove/Makefile

all:: snek-$(BOARD)-install snek-$(BOARD)-install.1

snek-$(BOARD)-install: snek-duemilanove-big-install.in
	$(SNEK_ATMEGA_SED) $^ > $@
	chmod +x $@

install:: $(HEX)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)

install:: snek-$(BOARD)-install snek-$(BOARD)-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-$(BOARD)-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-$(BOARD)-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f snek-$(BOARD)-install snek-$(BOARD)-install.1
	rm -f *.hex *.elf *.map
	rm -f ao-product.h

uninstall::

ISP=avrisp2

load: $(HEX) snek-$(BOARD)-install
	./snek-$(BOARD)-install -quick -isp $(ISP) -hex $(HEX) load

snek-$(BOARD)-install.1: snek-duemilanove-big-install.1.in
	$(SNEK_ATMEGA_SED) $^ > $@

=== ports/duemilanove/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

vpath %.in ../duemilanove

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega
BOARD?=duemilanove
CBOARD?=Duemilanove
UBOARD?=DUEMILANOVE
PORT?=/dev/ttyUSB0
CLOCK?=16000000
BAUD?=115200
INSTALLER?=1
ATMEGA_FLASH_SIZE?=0x7e00
MCU?=m328

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	snek-pow.c \
	snek-328p.c \
	$(SNEK_ATMEGA_SRC_EXTRA) \
	$(SNEK_ATMEGA_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	$(SNEK_ATMEGA_BUILTINS_EXTRA) \
	snek-328p.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_ATMEGA_SED=$(SNEK_SED) \
	-e 's;@BOARD@;$(BOARD);g' \
	-e 's;@UBOARD@;$(UBOARD);g' \
	-e 's;@CBOARD@;$(CBOARD);g' \
	-e 's;@BAUD@;$(BAUD);g' \
	-e 's;@PORT@;$(PORT);g' \
	-e 's;@MCU@;$(MCU);g'

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

BASE=snek-$(BOARD)-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
CC=avr-gcc

OPT=-Os -frename-registers -funsigned-char -fno-jump-tables -mcall-prologues

CFLAGS=$(OPT) -DUART_BAUD=$(BAUD) -DF_CPU=$(CLOCK)UL -mmcu=atmega328p -I. -I$(SNEK_LOCAL_VPATH) -g $(SNEK_CFLAGS) -Waddr-space-convert
LDFLAGS=$(SNEK_LDFLAGS) \
	-Wl,-uvfprintf -lprintf_flt -lm \
	-Wl,--defsym -Wl,__TEXT_REGION_LENGTH__=$(ATMEGA_FLASH_SIZE) \
	-Wl,-Map=$(MAP)

all:: $(HEX)

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@gawk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

ifeq ($(INSTALLER),1)
all:: snek-$(BOARD)-install snek-$(BOARD)-install.1

snek-$(BOARD)-install: snek-duemilanove-install.in
	$(SNEK_ATMEGA_SED) $^ > $@
	chmod +x $@

load: $(HEX) snek-$(BOARD)-install
	./snek-$(BOARD)-install -hex $(HEX)

snek-$(BOARD)-install.1: snek-duemilanove-install.1.in
	$(SNEK_ATMEGA_SED) $^ > $@

install: snek-$(BOARD)-install $(HEX) snek-$(BOARD)-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-$(BOARD)-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-$(BOARD)-install.1 $(DESTDIR)$(MANDIR)/man1

endif

clean::
	rm -f *.elf *.hex *.map snek-$(BOARD)-install snek-$(BOARD)-install.1

=== ports/grove/Makefile ===
#
# Copyright © 2020 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega
SNEK_NO_DICT = 1
SNEK_NO_SLICE = 1

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	snek-pow.c \
	snek-328p.c \
	snek-atmega-i2c.c \
	snek-ssd1315.c \
	snek-lis3dh.c \
	snek-input.c \
	$(SNEK_ATMEGA_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	snek-grove.builtin \
	snek-328p.builtin \
	snek-draw.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS) -DUART_BAUD=115200

BASE=snek-grove-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
CC=avr-gcc

OPT=-Os -frename-registers -funsigned-char -fno-jump-tables -mcall-prologues

CFLAGS=$(OPT) -DF_CPU=16000000UL -mmcu=atmega328p -I. -I$(SNEK_LOCAL_VPATH) -g $(SNEK_CFLAGS) -Waddr-space-convert
LDFLAGS=$(SNEK_LDFLAGS) \
	-Wl,-uvfprintf -lprintf_flt -lm \
	-Wl,--defsym -Wl,__TEXT_REGION_LENGTH__=0x7e00 \
	-Wl,-Map=$(MAP)

all: $(HEX) snek-grove-install

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@gawk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-grove-install: snek-grove-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

load: $(HEX) snek-grove-install
	./snek-grove-install -hex $(HEX)

install: snek-grove-install $(HEX) snek-grove-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-grove-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-grove-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f snek*.elf snek*.hex snek*.map snek-grove-install

=== ports/hifive1revb/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

PROGNAME=snek-hifive1revb
PRODUCT_NAME=snek-hifive1revb

# Note -- must set FREEDOM_METAL before building

FREEDOM_METAL ?= /must/set/FREEDOM_METAL

FREEDOM_METAL_PICO = $(FREEDOM_METAL)/pico
FREEDOM_METAL_GLOSS = $(FREEDOM_METAL)/gloss
LD_SCRIPT = metal.default.lds
FREEDOM_METAL_SRC = $(FREEDOM_METAL)/src
FREEDOM_METAL_DRIVERS = $(FREEDOM_METAL_SRC)/drivers
FREEDOM_METAL_INC = $(FREEDOM_METAL)

SNEK_LOCAL_VPATH = $(SNEK_FE310):$(SNEK_AO):$(FREEDOM_METAL_SRC):$(FREEDOM_METAL_DRIVERS):$(FREEDOM_METAL_PICO):$(FREEDOM_METAL_GLOSS)

PICOLIBC_PRINTF_CFLAGS = -DPICOLIBC_FLOAT_PRINTF_SCANF

PICOLIBC_CFLAGS= \
	-specs=picolibc.specs \
	-ffunction-sections \
	-fdata-sections \
	$(PICOLIBC_PRINTF_CFLAGS)

OPT=-Os -g

WARN_FLAGS=-Wall -Wextra -Wcast-align \
	-Wpointer-arith \
	-Wstrict-prototypes \
	-Wmissing-prototypes \
	-Wmissing-declarations \
	-Wnested-externs \
	-Wshadow \
	-Warray-bounds=2\
	-Wno-missing-prototypes\
	-Wno-unused-parameter\
	-Wno-strict-prototypes\
	-Wno-missing-declarations\
	-Wno-cast-align\
	-Wno-maybe-uninitialized

AO_CFLAGS=\
	-std=c18 $(WARN_FLAGS) $(OPT) -g

HIFIVE1REVB_CFLAGS=-march=rv32imac -mabi=ilp32 \
	-I. -I$(SNEK_ROOT) -I$(FREEDOM_METAL_INC) $(PICOLIBC_CFLAGS)

CFLAGS = $(HIFIVE1REVB_CFLAGS) $(SNEK_CFLAGS) $(AO_CFLAGS)

LDFLAGS=$(SNEK_LDFLAGS) $(CFLAGS) -n

LIBS=-lm

ARCH=riscv64-unknown-elf
CC=$(ARCH)-gcc
OBJCOPY=$(ARCH)-objcopy

PROG=$(PROGNAME)-$(SNEK_VERSION).elf
HEX=$(PROGNAME)-$(SNEK_VERSION).hex
MAP=$(PROGNAME)-$(SNEK_VERSION).map

.SUFFIXES: .elf .bin

.elf.bin:
	$(OBJCOPY) -O binary -S $^ $@

SNEK_LOCAL_SRC = \
	vector.S \
	entry.S \
	init.c \
	inline.c \
	fixed-clock.c \
	riscv_plic0.c \
	riscv_clint0.c \
	riscv_cpu.c \
	sifive_fe310-g000_prci.c \
	sifive_fe310-g000_hfrosc.c \
	sifive_fe310-g000_hfxosc.c \
	sifive_fe310-g000_lfrosc.c \
	sifive_fe310-g000_pll.c \
	sifive_uart0.c \
	sifive_spi0.c \
	sifive_gpio-leds.c \
	sifive_wdog0.c \
	sifive_rtc0.c \
	sifive_gpio0.c \
	sifive_i2c0.c \
	i2c.c \
	sifive_local-external-interrupts0.c \
	sys_exit.c \
	button.c \
	cache.c \
	clock.c \
	cpu.c \
	gpio.c \
	interrupt.c \
	led.c \
	lock.c \
	memory.c \
	pmp.c \
	privilege.c \
	rtc.c \
	shutdown.c \
	spi.c \
	switch.c \
	synchronize_harts.c \
	time.c \
	timer.c \
	trap.S \
	uart.c \
	watchdog.c \
	snek-metal.c \
	snek-math.c \
	snek-io.c \
	snek-input.c \
	snek-metal-gpio.c \
	snek-metal-uart.c \
	snek-metal-builtin.c

SNEK_LOCAL_INC = \
	$(SNEK_FE310_INC)

SNEK_LOCAL_BUILTINS = \
	snek-math.builtin \
	snek-gpio.builtin \
	snek-input.builtin \
	snek-hifive1revb.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(patsubst %.S,%.o,$(patsubst %.c,%.o,$(SRC)))

echo::
	echo $(OBJ)

all: $(PROG) $(HEX)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -T$(LD_SCRIPT) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(HEX): $(PROG)
	$(OBJCOPY) -O ihex -S $^ $@

$(OBJ): $(SNEK_INC) $(FREEDOM_METAL)

distclean:	clean

clean::
	rm -f *.o $(PROGNAME)*.elf $(PROGNAME)*.hex $(PROGNAME)*.map ao-product.h
	rm -f snek-board-install

snek-board-install: snek-board-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

echo::
	echo PROG is $(PROG)

install: $(PROG)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(PROG) $(DESTDIR)$(SHAREDIR)

uninstall:

$(FREEDOM_METAL):
	if [ ! -d $@ ]; then \
		echo "Need to set FREEDOM_METAL before building snek-hifive1revb";\
		exit 1;\
	fi

=== ports/itsybitsym0/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_SAMD21 = $(SNEK_ROOT)/chips/samd21

PROGNAME=snek-itsybitsym0
PRODUCT_NAME=SnekItsyBitsyM0
IDPRODUCT=0x8011
IDVENDOR=0x239A

include $(SNEK_SAMD21)/snek-samd21.defs

SNEK_LOCAL_SRC = \
	$(SNEK_SAMD21_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_SAMD21_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_SAMD21_BUILTINS) \
	snek-itsybitsym0.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(ELF) $(BIN) $(UF2)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

distclean:	clean

clean::
	rm -f *.o *.elf *.bin *.uf2 *.map ao-product.h

install: $(UF2)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(UF2) $(DESTDIR)$(SHAREDIR)

uninstall:

=== ports/lilypad-big/Makefile ===
#
# Copyright © 2020 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_DICT=1
BOARD=lilypad-big
CBOARD=LilyPad-big
UBOARD=LILYPAD-BIG
PORT=/dev/ttyUSB0
BAUD=57600
CLOCK=8000000
MCU=m328p

SNEK_ATMEGA_BUILTINS_EXTRA = \
	snek-tone.builtin \
	snek-input.builtin

include ../duemilanove-big/Makefile

=== ports/lilypad/Makefile ===
#
# Copyright © 2020 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_DICT=1
BOARD=lilypad
CBOARD=LilyPad
UBOARD=LILYPAD
PORT=/dev/ttyUSB0
BAUD=57600
CLOCK=8000000
MCU=m328p

SNEK_ATMEGA_BUILTINS_EXTRA = \
	snek-tone.builtin

include ../duemilanove/Makefile

=== ports/metrom0/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_SAMD21 = $(SNEK_ROOT)/chips/samd21

PROGNAME=snek-metrom0
PRODUCT_NAME=SnekMetroM0
IDPRODUCT=0x8013
IDVENDOR=0x239A

include $(SNEK_SAMD21)/snek-samd21.defs

SNEK_LOCAL_SRC = \
	$(SNEK_SAMD21_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_SAMD21_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_SAMD21_BUILTINS) \
	snek-metrom0.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(ELF) $(BIN) $(UF2)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

distclean:	clean

clean::
	rm -f *.o *.elf *.bin *.uf2 *.map ao-product.h

install: $(UF2)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(UF2) $(DESTDIR)$(SHAREDIR)

uninstall:

=== ports/nano-every/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega
BOARD?=nano-every
CBOARD?=NanoEvery
UBOARD?=NANOEVERY
PORT?=/dev/ttyACM0

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	snek-pow.c \
	snek-nano-every.c \
	snek-input.c \
	$(SNEK_ATMEGA_MATH_SRC) \
	$(SNEK_ATMEGA_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC) \
	$(SNEK_ATMEGA_MATH_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	snek-input.builtin \
	snek-math.builtin \
	snek-nano-every.builtin

include $(SNEK_ROOT)/snek-install.defs

AVR_ROOT=$(HOME)/misc/arduino/arduino-1.8.13/hardware/tools/avr

SNEK_NANO_EVERY_SED=$(SNEK_SED) \
	-e 's;@BOARD@;$(BOARD);g' \
	-e 's;@UBOARD@;$(UBOARD);g' \
	-e 's;@CBOARD@;$(CBOARD);g' \
	-e 's;@PORT@;$(PORT);g' \
	-e 's;@AVR_ROOT@;$(AVR_ROOT);g'

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

BASE=snek-$(BOARD)-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
CC=$(AVR_ROOT)/bin/avr-gcc

OPT=-Os -frename-registers -funsigned-char -fno-jump-tables -mcall-prologues

CFLAGS=$(OPT) -DF_CPU=20000000UL -mmcu=atmega4809 -I. -I$(SNEK_LOCAL_VPATH) -g $(SNEK_CFLAGS) -Waddr-space-convert
LDFLAGS=$(SNEK_LDFLAGS) \
	-Wl,-uvfprintf -lprintf_flt -lm \
	-Wl,-Map=$(MAP)

all: $(HEX) snek-$(BOARD)-install snek-$(BOARD)-install.1 snek-$(BOARD)-reset-port

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@gawk '/__data_load_end/{printf("ROM used: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-$(BOARD)-install: snek-nano-every-install.in
	$(SNEK_NANO_EVERY_SED) $^ > $@
	chmod +x $@

load: $(HEX) snek-$(BOARD)-install snek-$(BOARD)-reset-port
	./snek-$(BOARD)-install -reset ./snek-$(BOARD)-reset-port -hex $(HEX)

snek-$(BOARD)-install.1: snek-nano-every-install.1.in
	$(SNEK_NANO_EVERY_SED) $^ > $@

snek-$(BOARD)-reset-port: snek-nano-every-reset-port.c
	gcc -o $@ $^

install: snek-$(BOARD)-install $(HEX) snek-$(BOARD)-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-$(BOARD)-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install snek-$(BOARD)-reset-port $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-$(BOARD)-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f *.elf *.hex *.map snek-$(BOARD)-install snek-$(BOARD)-install.1 snek-$(BOARD)-reset-port

=== debian/changelog ===
snek (1.9-1) unstable; urgency=medium

  * New upstream version

  * Build with latest toolchain bits

  * Add '_' support

 -- Keith Packard <keithp@keithp.com>  Fri, 23 Dec 2022 21:50:47 -0800

snek (1.8-4) unstable; urgency=medium

  * Add bits for risc-v in autopkgtest. Closes: #1009206.

 -- Keith Packard <keithp@keithp.com>  Tue, 03 May 2022 13:44:53 -0700

=== debian/control ===
Source: snek
Section: interpreters
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), libreadline-dev, python3:any, lola, gawk
Build-Depends-Indep: avr-libc, gcc-avr,
 binutils-arm-none-eabi, gcc-arm-none-eabi, picolibc-arm-none-eabi (>= 1.4), qemu-system-arm,
 binutils-riscv64-unknown-elf, gcc-riscv64-unknown-elf, picolibc-riscv64-unknown-elf (>= 1.4),
 gcc-arm-linux-gnueabi, libc6-dev-armel-cross, qemu-system-misc,
 asciidoctor, ruby-asciidoctor-pdf, ruby-coderay
Standards-Version: 4.6.2
Homepage: https://sneklang.org
Vcs-Git: git://sneklang.org/git/snek.git
Vcs-Browser: https://sneklang.org/cgit/snek.git

Package: snek
Architecture: all
Suggests: snek-bin
Depends: ${misc:Depends}, python3:any, python3-serial, usbutils
Description: Embedded system programming language
 Snek is a small python-like language designed for embedded
 computers. It can run on systems as small as an Arduino Duemilanove
 board, which is an ATmega 328 processor with 32kB of flash and 2kB of
 ram. This package includes binaries and installation tools for many
 targets along with the snekde integrated development environment.

Package: snek-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, snek
Description: Host binary version of Snek programming language
 Snek is a small python-like language designed for embedded
 computers. It can run on systems as small as an Arduino Duemilanove
 board, which is an ATmega 328 processor with 32kB of flash and 2kB of
 ram. This package provides a host snek binary for playing with the
 language on your host machine.

=== debian/tests/control ===
Test-Command: make SNEK_NATIVE=/usr/bin/snek SNEK_ARM=/usr/share/snek/snek-arm SNEK_RISCV=/usr/share/snek/snek-riscv -C test check
Depends: @, qemu-system-arm, qemu-system-misc, gcc

=== debian/watch ===
version=4
opts="mode=git, gitmode=full, pgpmode=none" \
git://keithp.com/git/snek \
refs/tags/([\d\.]+) debian uupdate

## snek 1.10

=== ports/nano33iot/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..

SNEK_SAMD21 = $(SNEK_ROOT)/chips/samd21

PROGNAME=snek-nano33iot
PRODUCT_NAME=SnekNano33iot
IDPRODUCT=0x8057
IDVENDOR=0x2341

include $(SNEK_SAMD21)/snek-samd21.defs

SNEK_LOCAL_SRC = \
	$(SNEK_SAMD21_SRC)

SNEK_LOCAL_INC = \
	$(SNEK_SAMD21_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_SAMD21_BUILTINS) \
	snek-nano33iot.builtin

include $(SNEK_ROOT)/snek-install.defs

SRC=$(SNEK_SRC)
OBJ=$(SRC:.c=.o)

all: $(ELF) $(BIN) $(UF2)

$(PROG): Makefile $(OBJ)
	$(call quiet,CC) $(LDFLAGS) -Wl,-M=$(MAP) -o $@ $(OBJ) $(LIBS)

$(OBJ): $(SNEK_INC)

distclean:	clean

clean::
	rm -f *.o *.elf *.bin *.uf2 *.map ao-product.h

upload: $(BIN)
	bossac -e -w -v -b -R $(BIN)

install: $(UF2)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(UF2) $(DESTDIR)$(SHAREDIR)

uninstall:

=== debian/changelog ===
snek (1.10-1) unstable; urgency=medium

  * New upstream version

  * Adapt to new gcc-avr version. Closes: #1088139.

  * Depend on arch-specific qemu packages. Close: #1086204.

 -- Keith Packard <keithp@keithp.com>  Thu, 28 Nov 2024 12:30:53 -0800

snek (1.9-3) unstable; urgency=medium

  * Fix lintian errors

 -- Keith Packard <keithp@keithp.com>  Wed, 27 Sep 2023 11:27:47 -0700

snek (1.9-2) unstable; urgency=medium

  * Fix ev3 build to avoid inheriting host CFLAGS. Closes: #1052744.

 -- Keith Packard <keithp@keithp.com>  Tue, 26 Sep 2023 22:03:17 -0700

=== debian/control ===
--- 
+++ 
@@ -7,9 +7,9 @@
 Build-Depends-Indep: avr-libc, gcc-avr,
  binutils-arm-none-eabi, gcc-arm-none-eabi, picolibc-arm-none-eabi (>= 1.4), qemu-system-arm,
  binutils-riscv64-unknown-elf, gcc-riscv64-unknown-elf, picolibc-riscv64-unknown-elf (>= 1.4),
- gcc-arm-linux-gnueabi, libc6-dev-armel-cross, qemu-system-misc,
+ gcc-arm-linux-gnueabi, libc6-dev-armel-cross, qemu-system-riscv,
  asciidoctor, ruby-asciidoctor-pdf, ruby-coderay
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://sneklang.org
 Vcs-Git: git://sneklang.org/git/snek.git
 Vcs-Browser: https://sneklang.org/cgit/snek.git

## snek 1.11

=== Makefile ===
--- 
+++ 
@@ -35,10 +35,10 @@
 	+cd test && make $@
 
 black:
-	+black --check --exclude 'fail-syntax-.*\.py|.*/hosts/.*.py' .
+	+black --check --exclude 'fail-syntax-.*\.py|.*/hosts/.*.py|ubaboot.py' .
 
 black-reformat:
-	+black --exclude 'fail-syntax-.*\.py|.*/hosts/.*.py' .
+	+black --exclude 'fail-syntax-.*\.py|.*/hosts/.*.py|ubaboot.py' .
 
 install: all
 	+for dir in $(SUBDIRS); do (cd $$dir && make PREFIX=$(PREFIX) DESTDIR=$(DESTDIR) $@) || exit 1; done
@@ -46,13 +46,13 @@
 
 upload: otheros
 	+cd doc && make upload
-	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make upload); done
+	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make upload) || exit 1; done
 
 install-otheros: otheros install
-	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make install-otheros); done
+	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make install-otheros) || exit 1; done
 
 otheros: all
-	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make); done
+	+for otheros in $(SNEK_OTHEROS_DIR); do (cd "$$otheros" && make) || exit 1; done
 
 snek-mu.py:
 	find . -name '*.builtin' -print0 | xargs -0 python3 ./snek-builtin.py --mu -o $@

=== snekde/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT=..

include $(SNEK_ROOT)/snek-install.defs

all: snekde snekde.desktop

%:
	@echo done $@

install: snekde snekde.desktop snekde.1
	install -d $(DESTDIR)$(BINDIR)
	install snekde $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(APPDIR)
	install snekde.desktop $(DESTDIR)$(APPDIR)
	install -d $(DESTDIR)$(ICONDIR)
	install -m 644 ../snek.svg $(DESTDIR)$(ICONDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install snekde.1 $(DESTDIR)$(MANDIR)/man1

snekde.desktop: snekde.desktop.in
	$(SNEK_SED) $^ > $@

snekde: snekde.py
	cp $^ $@
	chmod +x $@

check:
	black --check snekde.py

clean::
	rm -f snekde snekde.desktop

=== hosts/macosx/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_NO_BUILD_TARGETS = 1
SNEK_ROOT=../..

include $(SNEK_ROOT)/snek-install.defs

MACOSX_RES=16 32 128 256 512
MACOSX_ICON_PNGS = $(shell for i in $(MACOSX_RES); do echo snek-$$i.png; done)
MACOSX_ICON = snek.icns
MACOSX_DIST = snek-mac-$(SNEK_VERSION).dmg

SNEKDE = $(SNEK_ROOT)/snekde/snekde.py
SNEKDE_SCRIPTS = runsnekde snekde-script
SNEKDE_FILES = $(SNEKDE_SCRIPTS) snekde-Info.plist $(SNEKDE)

ifneq ($(strip $(SNEKMAC)),)
SNEK = snek
SNEK_SCRIPTS =  runsnek snek-script
SNEK_FILES = $(SNEK_SCRIPTS) snek-Info.plist $(SNEK)
endif

MACOSX_INSTALL = install-macosx

MACOSX_DOCS = $(PDF) $(SNEK_ROOT)/COPYING ReadMe-Mac.rtf

MACOSX_FILES=$(SNEKDE_FILES) $(SNEK_FILES) serial $(MACOSX_ICON) $(MACOSX_SCRIPTS) $(MACOSX_INSTALL) $(MACOSX_DOCS) $(SNEK_ROOT)/examples/*.py

all: $(MACOSX_DIST)

$(MACOSX_ICON): $(SNEK_ROOT)/snek.svg
	for i in $(MACOSX_RES); do rsvg-convert -w $$i -h $$i -o snek-$$i.png $^; done
	png2icns $@ $(MACOSX_ICON_PNGS)

macosx: $(MACOSX_FILES)
	rm -rf macosx
	mkdir -p macosx/examples

ifeq ($(strip $(SNEKMAC)),)
snek-bits:
	echo 'no snek app'
else
snek-bits: $(SNEK_FILES) macosx
	#
	# snek
	#
	mkdir -p macosx/snek.app/Contents/Resources macosx/snek.app/Contents/MacOS
	echo 'APPLSN.O' > macosx/snek.app/Contents/PkgInfo
	cp -p snek-Info.plist macosx/snek.app/Contents/Info.plist
	cp -p $(MACOSX_ICON) macosx/snek.app/Contents/Resources
	cp -a $(SNEK) macosx/snek.app/Contents/Resources
	cp -p $(SNEK_SCRIPTS) macosx/snek.app/Contents/MacOS/
endif

$(MACOSX_DIST): $(MACOSX_FILES) macosx snek-bits
	rm -f $@
	cp -a $(MACOSX_DOCS) macosx
	cp -a $(MACOSX_INSTALL) macosx
	cp -a $(FIRMWARE) macosx
	cp -a $(USBFIRMWARE) macosx
	cp -a $(SNEK_ROOT)/examples/* macosx/examples
	#
	# snekde
	#
	mkdir -p macosx/snekde.app/Contents/Resources macosx/snekde.app/Contents/MacOS
	echo 'APPLSN.O' > macosx/snekde.app/Contents/PkgInfo
	cp -p snekde-Info.plist macosx/snekde.app/Contents/Info.plist
	cp -p $(MACOSX_ICON) macosx/snekde.app/Contents/Resources
	cp -a $(SNEKDE) macosx/snekde.app/Contents/Resources
	cp -a serial macosx/snekde.app/Contents/Resources
	cp -p $(SNEKDE_SCRIPTS) macosx/snekde.app/Contents/MacOS/
	#
	# generate iso image
	#
	genisoimage -D -V Snek-$(SNEK_VERSION) -no-pad -r -apple -o $@ macosx

serial: always
	rsync -a --delete --delete-excluded --exclude '__pycache__' --exclude '*.pyc' /usr/lib/python3/dist-packages/serial/ serial

always:

snekde-Info.plist: snekde-Info.plist.in
	$(SNEK_SED) $^ > $@

snek-Info.plist: snek-Info.plist.in
	$(SNEK_SED) $^ > $@

$(SNEK): FORCE
	./build-mac $(SNEKMAC) $@

FORCE:

install:
	echo install done

install-otheros: $(MACOSX_DIST)
	cp $(MACOSX_DIST) $(DESTDIR)$(PREFIX)

upload: $(MACOSX_DIST)
	rsync -avz $(MACOSX_DIST) $(SNEKDIST)

clean:
	rm -rf serial
	rm -rf snek
	rm -f $(MACOSX_ICON) $(MACOSX_ICON_PNGS)
	rm -f snekde-Info.plist snek-Info.plist
	rm -rf macosx *.dmg

=== ports/itsybitsy3v/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

AVR_CLOCK=8000000UL
PROGNAME=snek-itsybitsy3v
PRODUCT_NAME=SnekItsyBitsy3v
BUILD_INSTALL=0

SNEK_PORT=../itsybitsy5v

include ../itsybitsy5v/Makefile

=== ports/narrow-1284/Makefile ===
#
# Copyright © 2019 Keith Packard <keithp@keithp.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#

SNEK_ROOT = ../..
SNEK_ATMEGA = $(SNEK_ROOT)/chips/atmega

include $(SNEK_ATMEGA)/snek-atmega.defs

SNEK_LOCAL_VPATH = $(SNEK_ATMEGA)

SNEK_LOCAL_SRC = \
	snek-narrow-1284.c \
	$(SNEK_ATMEGA_SRC) \
	$(SNEK_ATMEGA_MATH_SRC) \
	snek-input.c

SNEK_LOCAL_INC = \
	$(SNEK_ATMEGA_INC) \
	$(SNEK_ATMEGA_MATH_INC)

SNEK_LOCAL_BUILTINS = \
	$(SNEK_ATMEGA_BUILTINS) \
	$(SNEK_ATMEGA_MATH_BUILTINS) \
	snek-math.builtin \
	snek-input.builtin \
	snek-narrow-1284.builtin

include $(SNEK_ROOT)/snek-install.defs

SNEK_CFLAGS = $(SNEK_MOST_WARNINGS) $(SNEK_BASE_CFLAGS)

BASE=snek-narrow-1284-$(SNEK_VERSION)
ELF=$(BASE).elf
HEX=$(BASE).hex
MAP=$(BASE).map
CC=avr-gcc
CFLAGS=-DF_CPU=16000000UL -mmcu=atmega1284 -I. -I$(SNEK_LOCAL_VPATH) -g -fno-jump-tables $(SNEK_CFLAGS) $(OPT) -Waddr-space-convert
LDFLAGS=$(SNEK_LDFLAGS) \
	-Wl,-uvfprintf -lprintf_flt -lm \
	-Wl,-Map=$(MAP)

PORT=/dev/ttyUSB0

all: $(HEX) snek-narrow-1284-install

$(HEX): $(ELF)
	avr-objcopy -O ihex -R .eeprom $^ $@

$(ELF): $(SNEK_OBJ)
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)
	@gawk '/__data_load_end/{printf("$(BASE) ROM: %d bytes\n", strtonum($$1)); }' $(MAP)

snek-narrow-1284-install: snek-narrow-1284-install.in
	$(SNEK_SED) $^ > $@
	chmod +x $@

load: $(HEX) snek-narrow-1284-install
	./snek-narrow-1284-install -port $(PORT) -hex $(HEX)

install: snek-narrow-1284-install $(HEX) $(USBSERIAL_HEX) snek-narrow-1284-install.1
	install -d $(DESTDIR)$(BINDIR)
	install snek-narrow-1284-install $(DESTDIR)$(BINDIR)
	install -d $(DESTDIR)$(SHAREDIR)
	install -m 0644 $(HEX) $(DESTDIR)$(SHAREDIR)
	install -d $(DESTDIR)$(MANDIR)/man1
	install -m 0644 snek-narrow-1284-install.1 $(DESTDIR)$(MANDIR)/man1

clean::
	rm -f *.elf snek*.hex *.map snek-narrow-1284-install

load-direct: $(HEX)
	avrdude -pm1284p -carduino -P$(PORT) -b115200 -D -Uflash:w:$(HEX):i

=== debian/changelog ===
snek (1.11-2) unstable; urgency=medium

  * Fix Risc-V32 qemu dependency. Closes: #1086024.

 -- Keith Packard <keithp@keithp.com>  Thu, 06 Feb 2025 15:25:14 -0800

snek (1.11-1) unstable; urgency=medium

  * switch debian/watch URL to use https

  * Stop building EV3 port as gcc-arm-linux-gnueabi is unavailable on
    armhf. Closes: #1091294.

 -- Keith Packard <keithp@keithp.com>  Thu, 06 Feb 2025 11:33:49 -0800

=== debian/control ===
--- 
+++ 
@@ -7,11 +7,11 @@
 Build-Depends-Indep: avr-libc, gcc-avr,
  binutils-arm-none-eabi, gcc-arm-none-eabi, picolibc-arm-none-eabi (>= 1.4), qemu-system-arm,
  binutils-riscv64-unknown-elf, gcc-riscv64-unknown-elf, picolibc-riscv64-unknown-elf (>= 1.4),
- gcc-arm-linux-gnueabi, libc6-dev-armel-cross, qemu-system-riscv,
+ qemu-system-riscv32,
  asciidoctor, ruby-asciidoctor-pdf, ruby-coderay
 Standards-Version: 4.7.0
 Homepage: https://sneklang.org
-Vcs-Git: git://sneklang.org/git/snek.git
+Vcs-Git: https://sneklang.org/cgit/snek.git
 Vcs-Browser: https://sneklang.org/cgit/snek.git
 
 Package: snek
